cipher.h File Reference

The generic cipher wrapper. More...

`#include "config.h"`
`#include <stddef.h>`
Include dependency graph for cipher.h:
This graph shows which files directly or indirectly include this file:

Go to the source code of this file.

## Data Structures

struct | mbedtls_cipher_info_t
struct | mbedtls_cipher_context_t

## Macros

#define | MBEDTLS_CIPHER_MODE_AEAD
#define | MBEDTLS_CIPHER_MODE_WITH_PADDING
#define | MBEDTLS_CIPHER_MODE_STREAM
#define | MBEDTLS_ERR_CIPHER_FEATURE_UNAVAILABLE -0x6080
#define | MBEDTLS_ERR_CIPHER_BAD_INPUT_DATA -0x6100
#define | MBEDTLS_ERR_CIPHER_ALLOC_FAILED -0x6180
#define | MBEDTLS_ERR_CIPHER_INVALID_PADDING -0x6200
#define | MBEDTLS_ERR_CIPHER_FULL_BLOCK_EXPECTED -0x6280
#define | MBEDTLS_ERR_CIPHER_AUTH_FAILED -0x6300
#define | MBEDTLS_ERR_CIPHER_INVALID_CONTEXT -0x6380
#define | MBEDTLS_ERR_CIPHER_HW_ACCEL_FAILED -0x6400
#define | MBEDTLS_CIPHER_VARIABLE_IV_LEN 0x01
#define | MBEDTLS_CIPHER_VARIABLE_KEY_LEN 0x02
#define | MBEDTLS_MAX_IV_LENGTH 16
#define | MBEDTLS_MAX_BLOCK_LENGTH 16

## Typedefs

typedef struct mbedtls_cipher_base_t | mbedtls_cipher_base_t
typedef struct mbedtls_cmac_context_t | mbedtls_cmac_context_t

## Enumerations

enum | mbedtls_cipher_id_t { MBEDTLS_CIPHER_ID_NONE = 0, MBEDTLS_CIPHER_ID_NULL, MBEDTLS_CIPHER_ID_AES, MBEDTLS_CIPHER_ID_DES, MBEDTLS_CIPHER_ID_3DES, MBEDTLS_CIPHER_ID_CAMELLIA, MBEDTLS_CIPHER_ID_BLOWFISH, MBEDTLS_CIPHER_ID_ARC4 }
| An enumeration of supported ciphers. More...

enum

mbedtls_cipher_type_t {
MBEDTLS_CIPHER_NONE = 0, MBEDTLS_CIPHER_NULL, MBEDTLS_CIPHER_AES_128_ECB, MBEDTLS_CIPHER_AES_192_ECB,
MBEDTLS_CIPHER_AES_256_ECB, MBEDTLS_CIPHER_AES_128_CBC, MBEDTLS_CIPHER_AES_192_CBC, MBEDTLS_CIPHER_AES_256_CBC,
MBEDTLS_CIPHER_AES_128_CFB128, MBEDTLS_CIPHER_AES_192_CFB128, MBEDTLS_CIPHER_AES_256_CFB128, MBEDTLS_CIPHER_AES_128_CTR,
MBEDTLS_CIPHER_AES_192_CTR, MBEDTLS_CIPHER_AES_256_CTR, MBEDTLS_CIPHER_AES_128_GCM, MBEDTLS_CIPHER_AES_192_GCM,
MBEDTLS_CIPHER_AES_256_GCM, MBEDTLS_CIPHER_CAMELLIA_128_ECB, MBEDTLS_CIPHER_CAMELLIA_192_ECB, MBEDTLS_CIPHER_CAMELLIA_256_ECB,
MBEDTLS_CIPHER_CAMELLIA_128_CBC, MBEDTLS_CIPHER_CAMELLIA_192_CBC, MBEDTLS_CIPHER_CAMELLIA_256_CBC, MBEDTLS_CIPHER_CAMELLIA_128_CFB128,
MBEDTLS_CIPHER_CAMELLIA_192_CFB128, MBEDTLS_CIPHER_CAMELLIA_256_CFB128, MBEDTLS_CIPHER_CAMELLIA_128_CTR, MBEDTLS_CIPHER_CAMELLIA_192_CTR,
MBEDTLS_CIPHER_CAMELLIA_256_CTR, MBEDTLS_CIPHER_CAMELLIA_128_GCM, MBEDTLS_CIPHER_CAMELLIA_192_GCM, MBEDTLS_CIPHER_CAMELLIA_256_GCM,
MBEDTLS_CIPHER_DES_ECB, MBEDTLS_CIPHER_DES_CBC, MBEDTLS_CIPHER_DES_EDE_ECB, MBEDTLS_CIPHER_DES_EDE_CBC,
MBEDTLS_CIPHER_DES_EDE3_ECB, MBEDTLS_CIPHER_DES_EDE3_CBC, MBEDTLS_CIPHER_BLOWFISH_ECB, MBEDTLS_CIPHER_BLOWFISH_CBC,
MBEDTLS_CIPHER_BLOWFISH_CFB64, MBEDTLS_CIPHER_BLOWFISH_CTR, MBEDTLS_CIPHER_ARC4_128, MBEDTLS_CIPHER_AES_128_CCM,
MBEDTLS_CIPHER_AES_192_CCM, MBEDTLS_CIPHER_AES_256_CCM, MBEDTLS_CIPHER_CAMELLIA_128_CCM, MBEDTLS_CIPHER_CAMELLIA_192_CCM,
MBEDTLS_CIPHER_CAMELLIA_256_CCM
}

| An enumeration of supported (cipher, mode) pairs. More...
enum | mbedtls_cipher_mode_t { MBEDTLS_MODE_NONE = 0, MBEDTLS_MODE_ECB, MBEDTLS_MODE_CBC, MBEDTLS_MODE_CFB, MBEDTLS_MODE_OFB, MBEDTLS_MODE_CTR, MBEDTLS_MODE_GCM, MBEDTLS_MODE_STREAM, MBEDTLS_MODE_CCM }
enum | mbedtls_cipher_padding_t { MBEDTLS_PADDING_PKCS7 = 0, MBEDTLS_PADDING_ONE_AND_ZEROS, MBEDTLS_PADDING_ZEROS_AND_LEN, MBEDTLS_PADDING_ZEROS, MBEDTLS_PADDING_NONE }
enum | mbedtls_operation_t { MBEDTLS_OPERATION_NONE = -1, MBEDTLS_DECRYPT = 0, MBEDTLS_ENCRYPT }
enum | { MBEDTLS_KEY_LENGTH_NONE = 0, MBEDTLS_KEY_LENGTH_DES = 64, MBEDTLS_KEY_LENGTH_DES_EDE = 128, MBEDTLS_KEY_LENGTH_DES_EDE3 = 192 }

## Functions

const int * | mbedtls_cipher_list (void)
| This function retrieves the list of ciphers supported by the generic cipher module. More...
const mbedtls_cipher_info_t * | mbedtls_cipher_info_from_string (const char *cipher_name)
| This function retrieves the cipher-information structure associated with the given cipher name. More...
const mbedtls_cipher_info_t * | mbedtls_cipher_info_from_type (const mbedtls_cipher_type_t cipher_type)
| This function retrieves the cipher-information structure associated with the given cipher type. More...
const mbedtls_cipher_info_t * | mbedtls_cipher_info_from_values (const mbedtls_cipher_id_t cipher_id, int key_bitlen, const mbedtls_cipher_mode_t mode)
| This function retrieves the cipher-information structure associated with the given cipher ID, key size and mode. More...
void | mbedtls_cipher_init (mbedtls_cipher_context_t *ctx)
| This function initializes a `cipher_context` as NONE. More...
void | mbedtls_cipher_free (mbedtls_cipher_context_t *ctx)
| This function frees and clears the cipher-specific context of `ctx`. Freeing `ctx` itself remains the responsibility of the caller. More...
int | mbedtls_cipher_setup (mbedtls_cipher_context_t *ctx, const mbedtls_cipher_info_t *cipher_info)
| This function initializes and fills the cipher-context structure with the appropriate values. It also clears the structure. More...
static unsigned int | mbedtls_cipher_get_block_size (const mbedtls_cipher_context_t *ctx)
| This function returns the block size of the given cipher. More...
static mbedtls_cipher_mode_t | mbedtls_cipher_get_cipher_mode (const mbedtls_cipher_context_t *ctx)
| This function returns the mode of operation for the cipher. For example, MBEDTLS_MODE_CBC. More...
static int | mbedtls_cipher_get_iv_size (const mbedtls_cipher_context_t *ctx)
| This function returns the size of the IV or nonce of the cipher, in Bytes. More...
static mbedtls_cipher_type_t | mbedtls_cipher_get_type (const mbedtls_cipher_context_t *ctx)
| This function returns the type of the given cipher. More...
static const char * | mbedtls_cipher_get_name (const mbedtls_cipher_context_t *ctx)
| This function returns the name of the given cipher as a string. More...
static int | mbedtls_cipher_get_key_bitlen (const mbedtls_cipher_context_t *ctx)
| This function returns the key length of the cipher. More...
static mbedtls_operation_t | mbedtls_cipher_get_operation (const mbedtls_cipher_context_t *ctx)
| This function returns the operation of the given cipher. More...
int | mbedtls_cipher_setkey (mbedtls_cipher_context_t *ctx, const unsigned char *key, int key_bitlen, const mbedtls_operation_t operation)
| This function sets the key to use with the given context. More...
int | mbedtls_cipher_set_padding_mode (mbedtls_cipher_context_t *ctx, mbedtls_cipher_padding_t mode)
| This function sets the padding mode, for cipher modes that use padding. More...
int | mbedtls_cipher_set_iv (mbedtls_cipher_context_t *ctx, const unsigned char *iv, size_t iv_len)
| This function sets the initialization vector (IV) or nonce. More...
int | mbedtls_cipher_reset (mbedtls_cipher_context_t *ctx)
| This function resets the cipher state. More...
int | mbedtls_cipher_update_ad (mbedtls_cipher_context_t *ctx, const unsigned char *ad, size_t ad_len)
| This function adds additional data for AEAD ciphers. Only supported with GCM. Must be called exactly once, after mbedtls_cipher_reset(). More...
int | mbedtls_cipher_update (mbedtls_cipher_context_t *ctx, const unsigned char *input, size_t ilen, unsigned char *output, size_t *olen)
| The generic cipher update function. It encrypts or decrypts using the given cipher context. Writes as many block-sized blocks of data as possible to output. Any data that cannot be written immediately is either added to the next block, or flushed when mbedtls_cipher_finish() is called. Exception: For MBEDTLS_MODE_ECB, expects a single block in size. For example, 16 Bytes for AES. More...
int | mbedtls_cipher_finish (mbedtls_cipher_context_t *ctx, unsigned char *output, size_t *olen)
| The generic cipher finalization function. If data still needs to be flushed from an incomplete block, the data contained in it is padded to the size of the last block, and written to the `output` buffer. More...
int | mbedtls_cipher_write_tag (mbedtls_cipher_context_t *ctx, unsigned char *tag, size_t tag_len)
| This function writes a tag for AEAD ciphers. Only supported with GCM. Must be called after mbedtls_cipher_finish(). More...
int | mbedtls_cipher_check_tag (mbedtls_cipher_context_t *ctx, const unsigned char *tag, size_t tag_len)
| This function checks the tag for AEAD ciphers. Only supported with GCM. Must be called after mbedtls_cipher_finish(). More...
int | mbedtls_cipher_crypt (mbedtls_cipher_context_t *ctx, const unsigned char *iv, size_t iv_len, const unsigned char *input, size_t ilen, unsigned char *output, size_t *olen)
| The generic all-in-one encryption/decryption function, for all ciphers except AEAD constructs. More...
int | mbedtls_cipher_auth_encrypt (mbedtls_cipher_context_t *ctx, const unsigned char *iv, size_t iv_len, const unsigned char *ad, size_t ad_len, const unsigned char *input, size_t ilen, unsigned char *output, size_t *olen, unsigned char *tag, size_t tag_len)
| The generic autenticated encryption (AEAD) function. More...
int | mbedtls_cipher_auth_decrypt (mbedtls_cipher_context_t *ctx, const unsigned char *iv, size_t iv_len, const unsigned char *ad, size_t ad_len, const unsigned char *input, size_t ilen, unsigned char *output, size_t *olen, const unsigned char *tag, size_t tag_len)
| The generic autenticated decryption (AEAD) function. More...

## Detailed Description

The generic cipher wrapper.

Author
  Adriaan de Jong dejon.nosp@m.g@fo.nosp@m.x-it..nosp@m.com

Definition in file cipher.h.

## Macro Definition Documentation

## MBEDTLS_CIPHER_MODE_AEAD

#define MBEDTLS_CIPHER_MODE_AEAD

Definition at line 39 of file cipher.h.

## MBEDTLS_CIPHER_MODE_STREAM

#define MBEDTLS_CIPHER_MODE_STREAM

Definition at line 47 of file cipher.h.

## MBEDTLS_CIPHER_MODE_WITH_PADDING

#define MBEDTLS_CIPHER_MODE_WITH_PADDING

Definition at line 43 of file cipher.h.

## MBEDTLS_CIPHER_VARIABLE_IV_LEN

#define MBEDTLS_CIPHER_VARIABLE_IV_LEN 0x01

Cipher accepts IVs of variable length.

Definition at line 64 of file cipher.h.

## MBEDTLS_CIPHER_VARIABLE_KEY_LEN

#define MBEDTLS_CIPHER_VARIABLE_KEY_LEN 0x02

Cipher accepts keys of variable length.

Definition at line 65 of file cipher.h.

## MBEDTLS_ERR_CIPHER_ALLOC_FAILED

#define MBEDTLS_ERR_CIPHER_ALLOC_FAILED -0x6180

Failed to allocate memory.

Definition at line 57 of file cipher.h.

## MBEDTLS_ERR_CIPHER_AUTH_FAILED

#define MBEDTLS_ERR_CIPHER_AUTH_FAILED -0x6300

Authentication failed (for AEAD modes).

Definition at line 60 of file cipher.h.

## MBEDTLS_ERR_CIPHER_BAD_INPUT_DATA

#define MBEDTLS_ERR_CIPHER_BAD_INPUT_DATA -0x6100

Bad input parameters.

Definition at line 56 of file cipher.h.

## MBEDTLS_ERR_CIPHER_FEATURE_UNAVAILABLE

#define MBEDTLS_ERR_CIPHER_FEATURE_UNAVAILABLE -0x6080

The selected feature is not available.

Definition at line 55 of file cipher.h.

## MBEDTLS_ERR_CIPHER_FULL_BLOCK_EXPECTED

#define MBEDTLS_ERR_CIPHER_FULL_BLOCK_EXPECTED -0x6280

Decryption of block requires a full block.

Definition at line 59 of file cipher.h.

## MBEDTLS_ERR_CIPHER_HW_ACCEL_FAILED

#define MBEDTLS_ERR_CIPHER_HW_ACCEL_FAILED -0x6400

Cipher hardware accelerator failed.

Definition at line 62 of file cipher.h.

## MBEDTLS_ERR_CIPHER_INVALID_CONTEXT

#define MBEDTLS_ERR_CIPHER_INVALID_CONTEXT -0x6380

The context is invalid. For example, because it was freed.

Definition at line 61 of file cipher.h.

## MBEDTLS_ERR_CIPHER_INVALID_PADDING

#define MBEDTLS_ERR_CIPHER_INVALID_PADDING -0x6200

Input data contains invalid padding and is rejected.

Definition at line 58 of file cipher.h.

## MBEDTLS_MAX_BLOCK_LENGTH

#define MBEDTLS_MAX_BLOCK_LENGTH 16

Maximum block size of any cipher, in Bytes.

Definition at line 191 of file cipher.h.

## MBEDTLS_MAX_IV_LENGTH

#define MBEDTLS_MAX_IV_LENGTH 16

Maximum length of any IV, in Bytes.

Definition at line 189 of file cipher.h.

## Typedef Documentation

## mbedtls_cipher_base_t

typedef struct mbedtls_cipher_base_t mbedtls_cipher_base_t

Base cipher information (opaque struct).

Definition at line 196 of file cipher.h.

## mbedtls_cmac_context_t

typedef struct mbedtls_cmac_context_t mbedtls_cmac_context_t

CMAC context (opaque struct).

Definition at line 201 of file cipher.h.

## Enumeration Type Documentation

## anonymous enum

anonymous enum

Enumerator
MBEDTLS_KEY_LENGTH_NONE | Undefined key length.
MBEDTLS_KEY_LENGTH_DES | Key length, in bits (including parity), for DES keys.
MBEDTLS_KEY_LENGTH_DES_EDE | Key length in bits, including parity, for DES in two-key EDE.
MBEDTLS_KEY_LENGTH_DES_EDE3 | Key length in bits, including parity, for DES in three-key EDE.

Definition at line 177 of file cipher.h.

## mbedtls_cipher_id_t

enum mbedtls_cipher_id_t

An enumeration of supported ciphers.

Warning
  ARC4 and DES are considered weak ciphers and their use constitutes a security risk. We recommend considering stronger ciphers instead.

Enumerator
MBEDTLS_CIPHER_ID_NONE |
MBEDTLS_CIPHER_ID_NULL |
MBEDTLS_CIPHER_ID_AES |
MBEDTLS_CIPHER_ID_DES |
MBEDTLS_CIPHER_ID_3DES |
MBEDTLS_CIPHER_ID_CAMELLIA |
MBEDTLS_CIPHER_ID_BLOWFISH |
MBEDTLS_CIPHER_ID_ARC4 |

Definition at line 78 of file cipher.h.

## mbedtls_cipher_mode_t

enum mbedtls_cipher_mode_t

Supported cipher modes.

Enumerator
MBEDTLS_MODE_NONE |
MBEDTLS_MODE_ECB |
MBEDTLS_MODE_CBC |
MBEDTLS_MODE_CFB |
MBEDTLS_MODE_OFB |
MBEDTLS_MODE_CTR |
MBEDTLS_MODE_GCM |
MBEDTLS_MODE_STREAM |
MBEDTLS_MODE_CCM |

Definition at line 149 of file cipher.h.

## mbedtls_cipher_padding_t

enum mbedtls_cipher_padding_t

Supported cipher padding types.

Enumerator
MBEDTLS_PADDING_PKCS7 | PKCS7 padding (default).
MBEDTLS_PADDING_ONE_AND_ZEROS | ISO/IEC 7816-4 padding.
MBEDTLS_PADDING_ZEROS_AND_LEN | ANSI X.923 padding.
MBEDTLS_PADDING_ZEROS | zero padding (not reversible).
MBEDTLS_PADDING_NONE | never pad (full blocks only).

Definition at line 162 of file cipher.h.

## mbedtls_cipher_type_t

enum mbedtls_cipher_type_t

An enumeration of supported (cipher, mode) pairs.

Warning
  ARC4 and DES are considered weak ciphers and their use constitutes a security risk. We recommend considering stronger ciphers instead.

Enumerator
MBEDTLS_CIPHER_NONE |
MBEDTLS_CIPHER_NULL |
MBEDTLS_CIPHER_AES_128_ECB |
MBEDTLS_CIPHER_AES_192_ECB |
MBEDTLS_CIPHER_AES_256_ECB |
MBEDTLS_CIPHER_AES_128_CBC |
MBEDTLS_CIPHER_AES_192_CBC |
MBEDTLS_CIPHER_AES_256_CBC |
MBEDTLS_CIPHER_AES_128_CFB128 |
MBEDTLS_CIPHER_AES_192_CFB128 |
MBEDTLS_CIPHER_AES_256_CFB128 |
MBEDTLS_CIPHER_AES_128_CTR |
MBEDTLS_CIPHER_AES_192_CTR |
MBEDTLS_CIPHER_AES_256_CTR |
MBEDTLS_CIPHER_AES_128_GCM |
MBEDTLS_CIPHER_AES_192_GCM |
MBEDTLS_CIPHER_AES_256_GCM |
MBEDTLS_CIPHER_CAMELLIA_128_ECB |
MBEDTLS_CIPHER_CAMELLIA_192_ECB |
MBEDTLS_CIPHER_CAMELLIA_256_ECB |
MBEDTLS_CIPHER_CAMELLIA_128_CBC |
MBEDTLS_CIPHER_CAMELLIA_192_CBC |
MBEDTLS_CIPHER_CAMELLIA_256_CBC |
MBEDTLS_CIPHER_CAMELLIA_128_CFB128 |
MBEDTLS_CIPHER_CAMELLIA_192_CFB128 |
MBEDTLS_CIPHER_CAMELLIA_256_CFB128 |
MBEDTLS_CIPHER_CAMELLIA_128_CTR |
MBEDTLS_CIPHER_CAMELLIA_192_CTR |
MBEDTLS_CIPHER_CAMELLIA_256_CTR |
MBEDTLS_CIPHER_CAMELLIA_128_GCM |
MBEDTLS_CIPHER_CAMELLIA_192_GCM |
MBEDTLS_CIPHER_CAMELLIA_256_GCM |
MBEDTLS_CIPHER_DES_ECB |
MBEDTLS_CIPHER_DES_CBC |
MBEDTLS_CIPHER_DES_EDE_ECB |
MBEDTLS_CIPHER_DES_EDE_CBC |
MBEDTLS_CIPHER_DES_EDE3_ECB |
MBEDTLS_CIPHER_DES_EDE3_CBC |
MBEDTLS_CIPHER_BLOWFISH_ECB |
MBEDTLS_CIPHER_BLOWFISH_CBC |
MBEDTLS_CIPHER_BLOWFISH_CFB64 |
MBEDTLS_CIPHER_BLOWFISH_CTR |
MBEDTLS_CIPHER_ARC4_128 |
MBEDTLS_CIPHER_AES_128_CCM |
MBEDTLS_CIPHER_AES_192_CCM |
MBEDTLS_CIPHER_AES_256_CCM |
MBEDTLS_CIPHER_CAMELLIA_128_CCM |
MBEDTLS_CIPHER_CAMELLIA_192_CCM |
MBEDTLS_CIPHER_CAMELLIA_256_CCM |

Definition at line 96 of file cipher.h.

## mbedtls_operation_t

enum mbedtls_operation_t

Type of operation.

Enumerator
MBEDTLS_OPERATION_NONE |
MBEDTLS_DECRYPT |
MBEDTLS_ENCRYPT |

Definition at line 171 of file cipher.h.

## Function Documentation

## mbedtls_cipher_auth_decrypt()

int mbedtls_cipher_auth_decrypt | ( | mbedtls_cipher_context_t * | ctx,
|  | const unsigned char * | iv,
|  | size_t | iv_len,
|  | const unsigned char * | ad,
|  | size_t | ad_len,
|  | const unsigned char * | input,
|  | size_t | ilen,
|  | unsigned char * | output,
|  | size_t * | olen,
|  | const unsigned char * | tag,
|  | size_t | tag_len
| ) |  |

The generic autenticated decryption (AEAD) function.

Parameters

  ctx | The generic cipher context.
  iv | The IV to use, or NONCE_COUNTER for CTR-mode ciphers.
  iv_len | The IV length for ciphers with variable-size IV. This parameter is discarded by ciphers with fixed-size IV.
  ad | The additional data to be authenticated.
  ad_len | The length of `ad`.
  input | The buffer holding the input data.
  ilen | The length of the input data.
  output | The buffer for the output data. Must be able to hold at least `ilen`.
  olen | The length of the output data, to be updated with the actual number of Bytes written.
  tag | The buffer holding the authentication tag.
  tag_len | The length of the authentication tag.

Returns
  `0` on success, or MBEDTLS_ERR_CIPHER_BAD_INPUT_DATA, or MBEDTLS_ERR_CIPHER_AUTH_FAILED if data is not authentic, or a cipher-specific error code on failure for any other reason.

Note
  If the data is not authentic, then the output buffer is zeroed out to prevent the unauthentic plaintext being used, making this interface safer.

Referenced by mbedtls_cipher_get_operation().

## mbedtls_cipher_auth_encrypt()

int mbedtls_cipher_auth_encrypt | ( | mbedtls_cipher_context_t * | ctx,
|  | const unsigned char * | iv,
|  | size_t | iv_len,
|  | const unsigned char * | ad,
|  | size_t | ad_len,
|  | const unsigned char * | input,
|  | size_t | ilen,
|  | unsigned char * | output,
|  | size_t * | olen,
|  | unsigned char * | tag,
|  | size_t | tag_len
| ) |  |

The generic autenticated encryption (AEAD) function.

Parameters

  ctx | The generic cipher context.
  iv | The IV to use, or NONCE_COUNTER for CTR-mode ciphers.
  iv_len | The IV length for ciphers with variable-size IV. This parameter is discarded by ciphers with fixed-size IV.
  ad | The additional data to authenticate.
  ad_len | The length of `ad`.
  input | The buffer holding the input data.
  ilen | The length of the input data.
  output | The buffer for the output data. Must be able to hold at least `ilen`.
  olen | The length of the output data, to be updated with the actual number of Bytes written.
  tag | The buffer for the authentication tag.
  tag_len | The desired length of the authentication tag.

Returns
  `0` on success, or MBEDTLS_ERR_CIPHER_BAD_INPUT_DATA, or a cipher-specific error code.

Referenced by mbedtls_cipher_get_operation().

## mbedtls_cipher_check_tag()

int mbedtls_cipher_check_tag | ( | mbedtls_cipher_context_t * | ctx,
|  | const unsigned char * | tag,
|  | size_t | tag_len
| ) |  |

This function checks the tag for AEAD ciphers. Only supported with GCM. Must be called after mbedtls_cipher_finish().

Parameters

  ctx | The generic cipher context.
  tag | The buffer holding the tag.
  tag_len | The length of the tag to check.

Returns
  `0` on success, or a specific error code on failure.

Referenced by mbedtls_cipher_get_operation().

## mbedtls_cipher_crypt()

int mbedtls_cipher_crypt | ( | mbedtls_cipher_context_t * | ctx,
|  | const unsigned char * | iv,
|  | size_t | iv_len,
|  | const unsigned char * | input,
|  | size_t | ilen,
|  | unsigned char * | output,
|  | size_t * | olen
| ) |  |

The generic all-in-one encryption/decryption function, for all ciphers except AEAD constructs.

Parameters

  ctx | The generic cipher context.
  iv | The IV to use, or NONCE_COUNTER for CTR-mode ciphers.
  iv_len | The IV length for ciphers with variable-size IV. This parameter is discarded by ciphers with fixed-size IV.
  input | The buffer holding the input data.
  ilen | The length of the input data.
  output | The buffer for the output data. Must be able to hold at least `ilen` + block_size. Must not be the same buffer as input.
  olen | The length of the output data, to be updated with the actual number of Bytes written.

Note
  Some ciphers do not use IVs nor nonce. For these ciphers, use `iv` = NULL and `iv_len` = 0.

Returns
  `0` on success, or MBEDTLS_ERR_CIPHER_BAD_INPUT_DATA, or MBEDTLS_ERR_CIPHER_FULL_BLOCK_EXPECTED if decryption expected a full block but was not provided one, or MBEDTLS_ERR_CIPHER_INVALID_PADDING on invalid padding while decrypting, or a cipher-specific error code on failure for any other reason.

Referenced by mbedtls_cipher_get_operation().

## mbedtls_cipher_finish()

int mbedtls_cipher_finish | ( | mbedtls_cipher_context_t * | ctx,
|  | unsigned char * | output,
|  | size_t * | olen
| ) |  |

The generic cipher finalization function. If data still needs to be flushed from an incomplete block, the data contained in it is padded to the size of the last block, and written to the `output` buffer.

Parameters

  ctx | The generic cipher context.
  output | The buffer to write data to. Needs block_size available.
  olen | The length of the data written to the `output` buffer.

Returns
  `0` on success, MBEDTLS_ERR_CIPHER_BAD_INPUT_DATA if parameter verification fails, MBEDTLS_ERR_CIPHER_FULL_BLOCK_EXPECTED if decryption expected a full block but was not provided one, MBEDTLS_ERR_CIPHER_INVALID_PADDING on invalid padding while decrypting, or a cipher-specific error code on failure for any other reason.

Referenced by mbedtls_cipher_get_operation().

## mbedtls_cipher_free()

void mbedtls_cipher_free | ( | mbedtls_cipher_context_t * | ctx | ) |

This function frees and clears the cipher-specific context of `ctx`. Freeing `ctx` itself remains the responsibility of the caller.

## mbedtls_cipher_get_block_size()

static unsigned int mbedtls_cipher_get_block_size | ( | const mbedtls_cipher_context_t * | ctx | ) |

inline static

This function returns the block size of the given cipher.

Parameters

  ctx | The context of the cipher. Must be initialized.

Returns
  The size of the blocks of the cipher, or zero if `ctx` has not been initialized.

Definition at line 374 of file cipher.h.

References mbedtls_cipher_info_t::block_size, and mbedtls_cipher_context_t::cipher_info.

## mbedtls_cipher_get_cipher_mode()

static mbedtls_cipher_mode_t mbedtls_cipher_get_cipher_mode | ( | const mbedtls_cipher_context_t * | ctx | ) |

inline static

This function returns the mode of operation for the cipher. For example, MBEDTLS_MODE_CBC.

Parameters

  ctx | The context of the cipher. Must be initialized.

Returns
  The mode of operation, or MBEDTLS_MODE_NONE if `ctx` has not been initialized.

Definition at line 391 of file cipher.h.

References mbedtls_cipher_context_t::cipher_info, MBEDTLS_MODE_NONE, and mbedtls_cipher_info_t::mode.

## mbedtls_cipher_get_iv_size()

static int mbedtls_cipher_get_iv_size | ( | const mbedtls_cipher_context_t * | ctx | ) |

inline static

This function returns the size of the IV or nonce of the cipher, in Bytes.

Parameters

  ctx | The context of the cipher. Must be initialized.

Returns
  - If no IV has been set: the recommended IV size. 0 for ciphers not using IV or nonce.
  - If IV has already been set: the actual size.

Definition at line 409 of file cipher.h.

References mbedtls_cipher_context_t::cipher_info, mbedtls_cipher_info_t::iv_size, and mbedtls_cipher_context_t::iv_size.

## mbedtls_cipher_get_key_bitlen()

static int mbedtls_cipher_get_key_bitlen | ( | const mbedtls_cipher_context_t * | ctx | ) |

inline static

This function returns the key length of the cipher.

Parameters

  ctx | The context of the cipher. Must be initialized.

Returns
  The key length of the cipher in bits, or MBEDTLS_KEY_LENGTH_NONE if ctx `has` not been initialized.

Definition at line 462 of file cipher.h.

References mbedtls_cipher_context_t::cipher_info, mbedtls_cipher_info_t::key_bitlen, and MBEDTLS_KEY_LENGTH_NONE.

## mbedtls_cipher_get_name()

static const char* mbedtls_cipher_get_name | ( | const mbedtls_cipher_context_t * | ctx | ) |

inline static

This function returns the name of the given cipher as a string.

Parameters

  ctx | The context of the cipher. Must be initialized.

Returns
  The name of the cipher, or NULL if `ctx` has not been not initialized.

Definition at line 445 of file cipher.h.

References mbedtls_cipher_context_t::cipher_info, and mbedtls_cipher_info_t::name.

## mbedtls_cipher_get_operation()

static mbedtls_operation_t mbedtls_cipher_get_operation | ( | const mbedtls_cipher_context_t * | ctx | ) |

inline static

This function returns the operation of the given cipher.

Parameters

  ctx | The context of the cipher. Must be initialized.

Returns
  The type of operation: MBEDTLS_ENCRYPT or MBEDTLS_DECRYPT, or MBEDTLS_OPERATION_NONE if `ctx` has not been initialized.

Definition at line 479 of file cipher.h.

References mbedtls_cipher_context_t::cipher_info, mbedtls_cipher_auth_decrypt(), mbedtls_cipher_auth_encrypt(), mbedtls_cipher_check_tag(), mbedtls_cipher_crypt(), mbedtls_cipher_finish(), mbedtls_cipher_reset(), mbedtls_cipher_set_iv(), mbedtls_cipher_set_padding_mode(), mbedtls_cipher_setkey(), mbedtls_cipher_update(), mbedtls_cipher_update_ad(), mbedtls_cipher_write_tag(), MBEDTLS_OPERATION_NONE, and mbedtls_cipher_context_t::operation.

## mbedtls_cipher_get_type()

static mbedtls_cipher_type_t mbedtls_cipher_get_type | ( | const mbedtls_cipher_context_t * | ctx | ) |

inline static

This function returns the type of the given cipher.

Parameters

  ctx | The context of the cipher. Must be initialized.

Returns
  The type of the cipher, or MBEDTLS_CIPHER_NONE if `ctx` has not been initialized.

Definition at line 428 of file cipher.h.

References mbedtls_cipher_context_t::cipher_info, MBEDTLS_CIPHER_NONE, and mbedtls_cipher_info_t::type.

## mbedtls_cipher_info_from_string()

const mbedtls_cipher_info_t* mbedtls_cipher_info_from_string | ( | const char * | cipher_name | ) |

This function retrieves the cipher-information structure associated with the given cipher name.

Parameters

  cipher_name | Name of the cipher to search for.

Returns
  The cipher information structure associated with the given `cipher_name`, or NULL if not found.

## mbedtls_cipher_info_from_type()

const mbedtls_cipher_info_t* mbedtls_cipher_info_from_type | ( | const mbedtls_cipher_type_t | cipher_type | ) |

This function retrieves the cipher-information structure associated with the given cipher type.

Parameters

  cipher_type | Type of the cipher to search for.

Returns
  The cipher information structure associated with the given `cipher_type`, or NULL if not found.

## mbedtls_cipher_info_from_values()

const mbedtls_cipher_info_t* mbedtls_cipher_info_from_values | ( | const mbedtls_cipher_id_t | cipher_id,
|  | int | key_bitlen,
|  | const mbedtls_cipher_mode_t | mode
| ) |  |

This function retrieves the cipher-information structure associated with the given cipher ID, key size and mode.

Parameters

  cipher_id | The ID of the cipher to search for. For example, MBEDTLS_CIPHER_ID_AES.
  key_bitlen | The length of the key in bits.
  mode | The cipher mode. For example, MBEDTLS_MODE_CBC.

Returns
  The cipher information structure associated with the given `cipher_id`, or NULL if not found.

## mbedtls_cipher_init()

void mbedtls_cipher_init | ( | mbedtls_cipher_context_t * | ctx | ) |

This function initializes a `cipher_context` as NONE.

## mbedtls_cipher_list()

const int* mbedtls_cipher_list | ( | void |  | ) |

This function retrieves the list of ciphers supported by the generic cipher module.

Returns
  A statically-allocated array of ciphers. The last entry is zero.

## mbedtls_cipher_reset()

int mbedtls_cipher_reset | ( | mbedtls_cipher_context_t * | ctx | ) |

This function resets the cipher state.

Parameters

  ctx | The generic cipher context.

Returns
  `0` on success, MBEDTLS_ERR_CIPHER_BAD_INPUT_DATA if parameter verification fails.

Referenced by mbedtls_cipher_get_operation().

## mbedtls_cipher_set_iv()

int mbedtls_cipher_set_iv | ( | mbedtls_cipher_context_t * | ctx,
|  | const unsigned char * | iv,
|  | size_t | iv_len
| ) |  |

This function sets the initialization vector (IV) or nonce.

Parameters

  ctx | The generic cipher context.
  iv | The IV to use, or NONCE_COUNTER for CTR-mode ciphers.
  iv_len | The IV length for ciphers with variable-size IV. This parameter is discarded by ciphers with fixed-size IV.

Returns
  `0` on success, or MBEDTLS_ERR_CIPHER_BAD_INPUT_DATA

Note
  Some ciphers do not use IVs nor nonce. For these ciphers, this function has no effect.

Referenced by mbedtls_cipher_get_operation().

## mbedtls_cipher_set_padding_mode()

int mbedtls_cipher_set_padding_mode | ( | mbedtls_cipher_context_t * | ctx,
|  | mbedtls_cipher_padding_t | mode
| ) |  |

This function sets the padding mode, for cipher modes that use padding.

The default passing mode is PKCS7 padding.

Parameters

  ctx | The generic cipher context.
  mode | The padding mode.

Returns
  `0` on success, MBEDTLS_ERR_CIPHER_FEATURE_UNAVAILABLE if the selected padding mode is not supported, or MBEDTLS_ERR_CIPHER_BAD_INPUT_DATA if the cipher mode does not support padding.

Referenced by mbedtls_cipher_get_operation().

## mbedtls_cipher_setkey()

int mbedtls_cipher_setkey | ( | mbedtls_cipher_context_t * | ctx,
|  | const unsigned char * | key,
|  | int | key_bitlen,
|  | const mbedtls_operation_t | operation
| ) |  |

This function sets the key to use with the given context.

Parameters

  ctx | The generic cipher context. May not be NULL. Must have been initialized using mbedtls_cipher_info_from_type() or mbedtls_cipher_info_from_string().
  key | The key to use.
  key_bitlen | The key length to use, in bits.
  operation | The operation that the key will be used for: MBEDTLS_ENCRYPT or MBEDTLS_DECRYPT.

Returns
  `0` on success, MBEDTLS_ERR_CIPHER_BAD_INPUT_DATA if parameter verification fails, or a cipher-specific error code.

Referenced by mbedtls_cipher_get_operation().

## mbedtls_cipher_setup()

int mbedtls_cipher_setup | ( | mbedtls_cipher_context_t * | ctx,
|  | const mbedtls_cipher_info_t * | cipher_info
| ) |  |

This function initializes and fills the cipher-context structure with the appropriate values. It also clears the structure.

Parameters

  ctx | The context to initialize. May not be NULL.
  cipher_info | The cipher to use.

Returns
  `0` on success, MBEDTLS_ERR_CIPHER_BAD_INPUT_DATA on parameter failure, MBEDTLS_ERR_CIPHER_ALLOC_FAILED if allocation of the cipher-specific context failed.

## mbedtls_cipher_update()

int mbedtls_cipher_update | ( | mbedtls_cipher_context_t * | ctx,
|  | const unsigned char * | input,
|  | size_t | ilen,
|  | unsigned char * | output,
|  | size_t * | olen
| ) |  |

The generic cipher update function. It encrypts or decrypts using the given cipher context. Writes as many block-sized blocks of data as possible to output. Any data that cannot be written immediately is either added to the next block, or flushed when mbedtls_cipher_finish() is called. Exception: For MBEDTLS_MODE_ECB, expects a single block in size. For example, 16 Bytes for AES.

Parameters

  ctx | The generic cipher context.
  input | The buffer holding the input data.
  ilen | The length of the input data.
  output | The buffer for the output data. Must be able to hold at least `ilen` + block_size. Must not be the same buffer as input.
  olen | The length of the output data, to be updated with the actual number of Bytes written.

Returns
  `0` on success, MBEDTLS_ERR_CIPHER_BAD_INPUT_DATA if parameter verification fails, MBEDTLS_ERR_CIPHER_FEATURE_UNAVAILABLE on an unsupported mode for a cipher, or a cipher-specific error code.

Note
  If the underlying cipher is GCM, all calls to this function, except the last one before mbedtls_cipher_finish(). Must have `ilen` as a multiple of the block_size.

Referenced by mbedtls_cipher_get_operation().

## mbedtls_cipher_update_ad()

int mbedtls_cipher_update_ad | ( | mbedtls_cipher_context_t * | ctx,
|  | const unsigned char * | ad,
|  | size_t | ad_len
| ) |  |

This function adds additional data for AEAD ciphers. Only supported with GCM. Must be called exactly once, after mbedtls_cipher_reset().

Parameters

  ctx | The generic cipher context.
  ad | The additional data to use.
  ad_len | the Length of `ad`.

Returns
  `0` on success, or a specific error code on failure.

Referenced by mbedtls_cipher_get_operation().

## mbedtls_cipher_write_tag()

int mbedtls_cipher_write_tag | ( | mbedtls_cipher_context_t * | ctx,
|  | unsigned char * | tag,
|  | size_t | tag_len
| ) |  |

This function writes a tag for AEAD ciphers. Only supported with GCM. Must be called after mbedtls_cipher_finish().

Parameters

  ctx | The generic cipher context.
  tag | The buffer to write the tag to.
  tag_len | The length of the tag to write.

Returns
  `0` on success, or a specific error code on failure.

Referenced by mbedtls_cipher_get_operation().